program benchmark;

uses sysutils,entiers,trier,triselection,triinsertionsequentiel,triinsertiondichotomique,tribulles,trifusion,trirapide;

function benchmarker(t : TEntiers; n : Integer; trier : TTrier) : Integer;
var
   t1,t2 : TTimeStamp;
begin
   t1:=DateTimeToTimeStamp(Time());
   trier(t,n);   
   t2:=DateTimeToTimeStamp(Time());
   benchmarker:=t2.time-t1.time
end; { benchmarker }

procedure afficherTempsPourTrier(t : TEntiers; n : Integer; trier : TTrier; nomTri : String);
var
   temps : Integer;
   c	 : String;  
begin
   temps:=benchmarker(t,n,trier);
   str(temps,c);
   writeln(nomTri,' : ',c,' ms'); 
end; { afficherTempsPourTrier }

var
   n	 : Integer;
   t	 : TEntiers;
begin
   n:=saisirNbElements();
   initialiserAleatoirement(t,n);
   afficherTempsPourTrier(t,n,@(TriRapide.trier),'Tri rapide');
   afficherTempsPourTrier(t,n,@(TriFusion.trier),'Tri par fusion');
   afficherTempsPourTrier(t,n,@(TriSelection.trier),'Tri par selection');
   afficherTempsPourTrier(t,n,@(TriInsertionSequentiel.trier),'Tri par insertion (recherche d''insertion sequentielle)');
   afficherTempsPourTrier(t,n,@(TriInsertionDichotomique.trier),'Tri par insertion (recherche d''insertion dichotomique)');   
   afficherTempsPourTrier(t,n,@(TriBulles.trier),'Tri a bulles')
end.
